rebol [
    title: "OldsKool Demo"
    version: 2.5
    date: 19/09/2003
    author: "Sbastien 'Jedi' Jeudy"
    email: s.jeudy@libertysurf.fr
    url: http://reboleur.free.fr
]


; variables gnrales
;taille-ecran: 320x256
;taille-ecran: 480x380
taille-ecran: 640x512
;taille-ecran: 800x600
;taille-ecran: 1024x768

; synchro puissance machine
ref-synchro: 150 ; (rfrence = 0.15s)
synchro-prec: (to-decimal now/time/precise) * 1000
nb-essais: 50
essai: 0
cycle: 0

; scroll1
cars1: " ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,:!?+-*/()"
bmp1: copy []
repeat c length? cars1 [ append bmp1 load join %c [ c ".bmp" ] ]
taille-car1: 32x64
nb-car-ecran1: to-integer (taille-ecran/x / taille-car1/x) + 3
scroll1: uppercase read %scroll1.txt
pos-scroll1: 0
pos-car1: 0x0
bord-ecran1: 50
sens-scroll1: 0
sens-inc1: 10
sens-max1: 27

; barre1
taille-barre1: 1024x38
barre1: load %barre1.bmp
pos-barre1: 0x0

; scroll2
cars2: " ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,!?():;$%-/&+*="
bmp2: copy []
repeat d length? cars2 [ append bmp2 load join %d [ d ".bmp" ] ]
taille-car2: 28x32
nb-car-ecran2: to-integer (taille-ecran/x / taille-car2/x) + 3
scroll2: uppercase read %scroll2.txt
pos-scroll2: 0
pos-car2: 0x0
bord-ecran2: 50
coeff-sin2: 30
nb-sin2: 2

; barre2
taille-barre2: 1024x10
barre2: load %barre2.bmp
pos-barre2: 0x0

; logo1
taille-logo1: 320x95
logo11: load %logo1.bmp
logo12: load %logo2.bmp
coeff-decal: 15
pos-logo1: 0x0
pos-logo1/x: negate taille-logo1/x
pos-logo1/y: (taille-ecran/y / 2) - (taille-logo1/y / 2) - coeff-decal
sens-logo1: 70x20

; lignes
pos-ligne10: pos-ligne11: 0x0
pos-ligne11/x: taille-ecran/x
pos-ligne10/y: pos-ligne11/y: (taille-ecran/y / 3.5) - coeff-decal
pos-ligne20: pos-ligne21: 0x0
pos-ligne21/x: taille-ecran/x
pos-ligne20/y: pos-ligne21/y: taille-ecran/y - (taille-ecran/y / 3.5) - coeff-decal
couleur-init: couleur-lignes: 0
rgb-lignes-inc: 25

; effets
largeur-effet: 150x150
origine-effet1: origine-effet2: 0x0
origine-effet1/x: (taille-ecran/x / 4) - (largeur-effet/x / 2)
origine-effet2/x: (3 * taille-ecran/x / 4) - (largeur-effet/x / 2)
origine-effet1/y: origine-effet2/y: (taille-ecran/y / 2) - (largeur-effet/y / 2) - coeff-decal


mef-demo: does [
    ; synchro puissance machine
    if essai < nb-essais [
        essai: essai + 1
        synchro: (to-decimal now/time/precise) * 1000
        coeff-corr: (synchro - synchro-prec) / ref-synchro
        if coeff-corr > 1 [ coeff-corr: 1 ]
        synchro-prec: synchro
    ]
    cycle: cycle + 1

    ; mise en forme de la dmo
    clearcadre-ecran/effect/draw
    pos-car1/x: negate (taille-car1/x + to-integer (taille-car1/x * coeff-corr * cycle))
    pos-car2/x: negate (taille-car2/x + to-integer (taille-car2/x * coeff-corr * cycle))
    pos-car1/y: 0
    pos-car2/y: 0

    ; barre1 (derrire)
    pos-barre1/y: taille-ecran/y - bord-ecran1 - (taille-car1/y / 2) - (taille-barre1/y / 2) + sens-scroll1
    if sens-inc1 > 0 [
    append cadre-ecran/effect/draw reduce [
        'image pos-barre1 barre1 0.0.0
    ] ]

    ; scroll1
    repeat n1 nb-car-ecran1 [
        pos1: n1
        either pos1 < (nb-car-ecran1 - pos-scroll1) [
            car1: if find cars1 " " [ select bmp1 index? find cars1 " " ]
        ] [ pos1: pos-scroll1 + n1 - nb-car-ecran1
            car1: if find cars1 scroll1/:pos1 [ pick bmp1 index? find cars1 scroll1/:pos1 ] ]

        append cadre-ecran/effect/draw reduce [
            'image pos-car1 car1 0.0.0
        ]
        pos-car1/x: pos-car1/x + taille-car1/x
        pos-car1/y: taille-ecran/y - taille-car1/y - bord-ecran1 - sens-scroll1
    ]

    ; barre1 (devant)
    if sens-inc1 < 0 [
    append cadre-ecran/effect/draw reduce [
        'image pos-barre1 barre1 0.0.0
    ] ]

    ; barre2 (derrire)
    pos-barre2/y: bord-ecran2 - (coeff-sin2 / 2)
    append cadre-ecran/effect/draw reduce [
        'image pos-barre2 barre2 0.0.0
    ]
    pos-barre2/y: bord-ecran2 + (coeff-sin2 / 2) + (taille-barre2/y / 2) + (taille-car2/y / 2)
    append cadre-ecran/effect/draw reduce [
        'image pos-barre2 barre2 0.0.0
    ]

    ; scroll2
    repeat n2 nb-car-ecran2 [
        pos2: n2
        either pos2 < (nb-car-ecran2 - pos-scroll2) [
            car2: if find cars2 " " [ select bmp2 index? find cars2 " " ]
        ] [ pos2: pos-scroll2 + n2 - nb-car-ecran2
            car2: if find cars2 scroll2/:pos2 [ pick bmp2 index? find cars2 scroll2/:pos2 ] ]

        append cadre-ecran/effect/draw reduce [
            'image pos-car2 car2 0.0.0
        ]
        pos-car2/x: pos-car2/x + taille-car2/x
        pos-car2/y: bord-ecran2 + (coeff-sin2 * sine ((pos-car2/x / taille-ecran/x) * nb-sin2 * 360))
    ]

    ; barre2 (devant)
    pos-barre2/y: bord-ecran2 - (taille-barre2/y / 2) + (taille-car2/y / 2)
    append cadre-ecran/effect/draw reduce [
        'image pos-barre2 barre2 0.0.0
    ]

    ; logo1
    either sens-logo1/x > 0 [
        logo1: logo11
    ] [ logo1: logo12 ]
    append cadre-ecran/effect/draw reduce [
        'image pos-logo1 logo1 0.0.0
    ]

    ; lignes
    rlignes: glignes: blignes: couleur-lignes
    rgb-lignes: to-tuple reduce [ rlignes glignes blignes ]
    append cadre-ecran/effect/draw reduce [
        'pen rgb-lignes 'line pos-ligne10 pos-ligne11
    ]
    append cadre-ecran/effect/draw reduce [
        'pen rgb-lignes 'line pos-ligne20 pos-ligne21
    ]

    ; effets
    clearcadre-effet1/effect
    clearcadre-effet2/effect
    append cadre-effet1/effect reduce [ 'merge 'tint 60 ]
    append cadre-effet1/effect reduce [ 'merge 'flip 1x1 ]
    append cadre-effet2/effect reduce [ 'merge 'tint 60 ]
    append cadre-effet2/effect reduce [ 'merge 'flip 1x1 ]

    ; calcul de la suite
    sens-scroll1: sens-scroll1 + to-integer (sens-inc1 * coeff-corr)
    if sens-scroll1 > sens-max1 [
        sens-inc1: negate sens-inc1
        sens-scroll1: sens-max1 - 1
    ]
    if sens-scroll1 < negate sens-max1 [
        sens-inc1: negate sens-inc1
        sens-scroll1: negate sens-max1 + 1
    ]

    if (coeff-corr * cycle) >= 1 [ pos-scroll1: pos-scroll1 + 1 pos-scroll2: pos-scroll2 + 1 ]
    if pos-scroll1 > ((length? scroll1) + nb-car-ecran1) [ pos-scroll1: 0 ]
    if pos-scroll2 > ((length? scroll2) + nb-car-ecran2) [ pos-scroll2: 0 ]

    pos-logo1/x: pos-logo1/x + to-integer (sens-logo1/x * coeff-corr)
    pos-logo1/y: pos-logo1/y + to-integer (sens-logo1/y * coeff-corr)
    if pos-logo1/x > (taille-ecran/x + 50) [
        sens-logo1/x: negate sens-logo1/x
        pos-logo1/x: taille-ecran/x + 49
    ]
    if pos-logo1/x < negate (taille-logo1/x + 30) [
        sens-logo1/x: negate sens-logo1/x
        pos-logo1/x: negate (taille-logo1/x + 29)
    ]
    if pos-logo1/y > (pos-ligne20/y - taille-logo1/y - 5) [
        sens-logo1/y: negate sens-logo1/y
        pos-logo1/y: pos-ligne20/y - taille-logo1/y - 6
    ]
    if pos-logo1/y < (pos-ligne10/y + 5) [
        sens-logo1/y: negate sens-logo1/y
        pos-logo1/y: pos-ligne10/y + 6
    ]

    couleur-lignes: couleur-lignes + to-integer (rgb-lignes-inc * coeff-corr)
    if couleur-lignes < couleur-init [
        couleur-lignes: couleur-init + 1
        rgb-lignes-inc: negate rgb-lignes-inc
    ]
    if couleur-lignes > (255 - rgb-lignes-inc) [
        couleur-lignes: 254 - rgb-lignes-inc
        rgb-lignes-inc: negate rgb-lignes-inc
    ]

    if (coeff-corr * cycle) >= 1 [ cycle: 0 ]

    ; on affiche tout
    show cadre-ecran
]


view center-face layout/size [
    backcolor black

    ; mise en forme de l'cran
    origin 0x0
    cadre-ecran: box taille-ecran rate 0:0:0.001 feel [
        engage: func [ f a e ] [
            ; timer
            if a = 'time [
                ; mise en forme de la dmo
                mef-demo
            ]
        ]
    ] effect [ draw [] ]

    ; effets
    origin origine-effet1
    cadre-effet1: box largeur-effet edge [ color: 128.128.128 size: 2x2 ] effect []
    origin origine-effet2
    cadre-effet2: box largeur-effet edge [ color: 128.128.128 size: 2x2 ] effect []

] taille-ecran

